# Add Members Custom audiences

> Source: https://truto.one/docs/api-reference/unified-ads-management-api/customaudiences/add_members/

`POST /unified/ads/custom_audiences/add_members`

Resource: **CustomAudiences** · API: **Unified Ads Management API**

## Supported integrations

Google Ads, LinkedIn, Meta Marketing API

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`account_id`** _(string)_
  The unique identifier for the account.
- **`custom_audience_id`** _(string)_
- **`members`** _(array<object>)_
  A list of audience members.
  - **`first_name`** _(string)_
    Set only if type is USER. The first name of the user.
  - **`last_name`** _(string)_
    Set only if type is USER. The last name of the user.
  - **`title`** _(string)_
    Set only if type is USER. The job title of the user.
  - **`company`** _(string)_
    The name of the company.
  - **`country`** _(string)_
    The country associated with the user or company.
  - **`url`** _(string)_
  - **`keyword`** _(string)_
  - **`email`** _(string)_
    Set only if type is USER. The email address of the user.
  - **`phone`** _(string)_
  - **`application`** _(string)_
  - **`location_category`** _(string)_
  - **`google_advertiser_id`** _(string)_
    Set only if type is USER. The Google Advertiser ID of the user.
  - **`website`** _(string)_
    Set only if type is COMPANY. The website domain of the company.
  - **`domain`** _(string)_
    Set only if type is COMPANY. The email domain of the company.
  - **`organization_urn`** _(string)_
    Set only if type is COMPANY. The unique organization URN (Uniform Resource Name).
  - **`linkedin_url`** _(string)_
    Set only if type is COMPANY. The LinkedIn URL of the company.
  - **`third_party_user_id`** _(string)_
  - **`mobile_id`** _(string)_
  - **`gender`** _(string)_
  - **`state`** _(string)_
  - **`city`** _(string)_
  - **`postal_code`** _(string)_
- **`type`** _(string)_
  The type of custom audience.
  Allowed: `USER`, `COMPANY`
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string)_
  The unique identifier for the custom audience.
- **`name`** _(string)_
  The name of the custom audience.
- **`description`** _(string)_
  The description of the custom audience.
- **`type`** _(string)_
  The type of custom audience.
- **`source`** _(string)_
  The source of custom audience.
- **`status`** _(string)_
  The status of the custom audience.
  Allowed: `active`, `inactive`, `archived`, `deleted`, `with_issues`, `in_progress`, `failed`, `expired`
- **`account_id`** _(string)_
  The unique identifier for the account.
- **`members`** _(array<object>)_
  A list of audience members.
  - **`first_name`** _(string)_
  - **`last_name`** _(string)_
  - **`title`** _(string)_
  - **`company`** _(string)_
  - **`country`** _(string)_
  - **`url`** _(string)_
  - **`keyword`** _(string)_
  - **`email`** _(string)_
  - **`phone`** _(string)_
  - **`application`** _(string)_
  - **`location_category`** _(string)_
  - **`google_advertiser_id`** _(string)_
  - **`website`** _(string)_
  - **`domain`** _(string)_
  - **`organization_urn`** _(string)_
  - **`linkedin_url`** _(string)_
  - **`third_party_user_id`** _(string)_
  - **`mobile_id`** _(string)_
- **`created_at`** _(string)_
  The date and time the account was created.
- **`updated_at`** _(string)_
  The date and time the account was last updated.
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/ads/custom_audiences/add_members?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "account_id": "your_account_id",
  "custom_audience_id": "your_custom_audience_id",
  "members": [],
  "type": "USER",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "account_id": "your_account_id",
  "custom_audience_id": "your_custom_audience_id",
  "members": [],
  "type": "USER",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/ads/custom_audiences/add_members?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ads/custom_audiences/add_members"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "account_id": "your_account_id",
    "custom_audience_id": "your_custom_audience_id",
    "members": [],
    "type": "USER",
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

// Custom method: add_members
const result = await truto.unifiedApi.add_members(
  'ads',
  'customaudiences',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    # Custom method: add_members
    result = await truto_api.unified_api.add_members(
        "ads",
        "customaudiences",
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
